/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.32.0(e1570658ecca35c72429e624c18df24ae4286ef8)
 * Released under the MIT license
 * https://github.com/microsoft/monaco-editor/blob/main/LICENSE.txt
 *-----------------------------------------------------------------------------*/
define("vs/language/typescript/tsMode", ["require","require"],(require)=>{
var moduleExports=(()=>{var ee=Object.create;var P=Object.defineProperty;var te=Object.getOwnPropertyDescriptor;var ie=Object.getOwnPropertyNames;var re=Object.getPrototypeOf,se=Object.prototype.hasOwnProperty;var K=n=>P(n,"__esModule",{value:!0});var G=(n=>typeof require!="undefined"?require:typeof Proxy!="undefined"?new Proxy(n,{get:(e,t)=>(typeof require!="undefined"?require:e)[t]}):n)(function(n){if(typeof require!="undefined")return require.apply(this,arguments);throw new Error('Dynamic require of "'+n+'" is not supported')});var ne=(n,e)=>()=>(e||n((e={exports:{}}).exports,e),e.exports),oe=(n,e)=>{K(n);for(var t in e)P(n,t,{get:e[t],enumerable:!0})},B=(n,e,t)=>{if(e&&typeof e=="object"||typeof e=="function")for(let i of ie(e))!se.call(n,i)&&i!=="default"&&P(n,i,{get:()=>e[i],enumerable:!(t=te(e,i))||t.enumerable});return n},j=n=>B(K(P(n!=null?ee(re(n)):{},"default",n&&n.__esModule&&"default"in n?{get:()=>n.default,enumerable:!0}:{value:n,enumerable:!0})),n);var q=ne((me,Q)=>{var ae=j(G("vs/editor/editor.api"));Q.exports=ae});var pe={};oe(pe,{Adapter:()=>k,CodeActionAdaptor:()=>H,DefinitionAdapter:()=>O,DiagnosticsAdapter:()=>L,FormatAdapter:()=>N,FormatHelper:()=>x,FormatOnTypeAdapter:()=>W,InlayHintsAdapter:()=>V,Kind:()=>l,LibFiles:()=>F,OccurrencesAdapter:()=>A,OutlineAdapter:()=>E,QuickInfoAdapter:()=>M,ReferenceAdapter:()=>R,RenameAdapter:()=>U,SignatureHelpAdapter:()=>w,SuggestAdapter:()=>y,WorkerManager:()=>C,flattenDiagnosticMessageText:()=>D,getJavaScriptWorker:()=>ue,getTypeScriptWorker:()=>ge,setupJavaScript:()=>ce,setupTypeScript:()=>le});var r={};K(r);B(r,j(q()));var C=class{constructor(e,t){this._modeId=e,this._defaults=t,this._worker=null,this._client=null,this._configChangeListener=this._defaults.onDidChange(()=>this._stopWorker()),this._updateExtraLibsToken=0,this._extraLibsChangeListener=this._defaults.onDidExtraLibsChange(()=>this._updateExtraLibs())}_stopWorker(){this._worker&&(this._worker.dispose(),this._worker=null),this._client=null}dispose(){this._configChangeListener.dispose(),this._extraLibsChangeListener.dispose(),this._stopWorker()}async _updateExtraLibs(){if(!this._worker)return;let e=++this._updateExtraLibsToken,t=await this._worker.getProxy();this._updateExtraLibsToken===e&&t.updateExtraLibs(this._defaults.getExtraLibs())}_getClient(){if(!this._client){this._worker=r.editor.createWebWorker({moduleId:"vs/language/typescript/tsWorker",label:this._modeId,keepIdleModels:!0,createData:{compilerOptions:this._defaults.getCompilerOptions(),extraLibs:this._defaults.getExtraLibs(),customWorkerPath:this._defaults.workerOptions.customWorkerPath,inlayHintsOptions:this._defaults.inlayHintsOptions}});let e=this._worker.getProxy();this._defaults.getEagerModelSync()&&(e=e.then(t=>this._worker?this._worker.withSyncedResources(r.editor.getModels().filter(i=>i.getLanguageId()===this._modeId).map(i=>i.uri)):t)),this._client=e}return this._client}getLanguageServiceWorker(...e){let t;return this._getClient().then(i=>{t=i}).then(i=>{if(this._worker)return this._worker.withSyncedResources(e)}).then(i=>t)}};var X=j(G("./monaco.contribution"));var a={};a["lib.d.ts"]=!0;a["lib.dom.d.ts"]=!0;a["lib.dom.iterable.d.ts"]=!0;a["lib.es2015.collection.d.ts"]=!0;a["lib.es2015.core.d.ts"]=!0;a["lib.es2015.d.ts"]=!0;a["lib.es2015.generator.d.ts"]=!0;a["lib.es2015.iterable.d.ts"]=!0;a["lib.es2015.promise.d.ts"]=!0;a["lib.es2015.proxy.d.ts"]=!0;a["lib.es2015.reflect.d.ts"]=!0;a["lib.es2015.symbol.d.ts"]=!0;a["lib.es2015.symbol.wellknown.d.ts"]=!0;a["lib.es2016.array.include.d.ts"]=!0;a["lib.es2016.d.ts"]=!0;a["lib.es2016.full.d.ts"]=!0;a["lib.es2017.d.ts"]=!0;a["lib.es2017.full.d.ts"]=!0;a["lib.es2017.intl.d.ts"]=!0;a["lib.es2017.object.d.ts"]=!0;a["lib.es2017.sharedmemory.d.ts"]=!0;a["lib.es2017.string.d.ts"]=!0;a["lib.es2017.typedarrays.d.ts"]=!0;a["lib.es2018.asyncgenerator.d.ts"]=!0;a["lib.es2018.asynciterable.d.ts"]=!0;a["lib.es2018.d.ts"]=!0;a["lib.es2018.full.d.ts"]=!0;a["lib.es2018.intl.d.ts"]=!0;a["lib.es2018.promise.d.ts"]=!0;a["lib.es2018.regexp.d.ts"]=!0;a["lib.es2019.array.d.ts"]=!0;a["lib.es2019.d.ts"]=!0;a["lib.es2019.full.d.ts"]=!0;a["lib.es2019.object.d.ts"]=!0;a["lib.es2019.string.d.ts"]=!0;a["lib.es2019.symbol.d.ts"]=!0;a["lib.es2020.bigint.d.ts"]=!0;a["lib.es2020.d.ts"]=!0;a["lib.es2020.full.d.ts"]=!0;a["lib.es2020.intl.d.ts"]=!0;a["lib.es2020.promise.d.ts"]=!0;a["lib.es2020.sharedmemory.d.ts"]=!0;a["lib.es2020.string.d.ts"]=!0;a["lib.es2020.symbol.wellknown.d.ts"]=!0;a["lib.es2021.d.ts"]=!0;a["lib.es2021.full.d.ts"]=!0;a["lib.es2021.intl.d.ts"]=!0;a["lib.es2021.promise.d.ts"]=!0;a["lib.es2021.string.d.ts"]=!0;a["lib.es2021.weakref.d.ts"]=!0;a["lib.es5.d.ts"]=!0;a["lib.es6.d.ts"]=!0;a["lib.esnext.d.ts"]=!0;a["lib.esnext.full.d.ts"]=!0;a["lib.esnext.intl.d.ts"]=!0;a["lib.esnext.promise.d.ts"]=!0;a["lib.esnext.string.d.ts"]=!0;a["lib.esnext.weakref.d.ts"]=!0;a["lib.scripthost.d.ts"]=!0;a["lib.webworker.d.ts"]=!0;a["lib.webworker.importscripts.d.ts"]=!0;a["lib.webworker.iterable.d.ts"]=!0;var $;(function(i){i[i.None=0]="None",i[i.Block=1]="Block",i[i.Smart=2]="Smart"})($||($={}));function D(n,e,t=0){if(typeof n=="string")return n;if(n===void 0)return"";let i="";if(t){i+=e;for(let o=0;o<t;o++)i+="  "}if(i+=n.messageText,t++,n.next)for(let o of n.next)i+=D(o,e,t);return i}function S(n){return n?n.map(e=>e.text).join(""):""}var k=class{constructor(e){this._worker=e}_textSpanToRange(e,t){let i=e.getPositionAt(t.start),o=e.getPositionAt(t.start+t.length),{lineNumber:u,column:d}=i,{lineNumber:g,column:s}=o;return{startLineNumber:u,startColumn:d,endLineNumber:g,endColumn:s}}},F=class{constructor(e){this._worker=e;this._libFiles={},this._hasFetchedLibFiles=!1,this._fetchLibFilesPromise=null}isLibFile(e){return e&&e.path.indexOf("/lib.")===0?!!a[e.path.slice(1)]:!1}getOrCreateModel(e){let t=r.Uri.parse(e),i=r.editor.getModel(t);if(i)return i;if(this.isLibFile(t)&&this._hasFetchedLibFiles)return r.editor.createModel(this._libFiles[t.path.slice(1)],"typescript",t);let o=X.typescriptDefaults.getExtraLibs()[e];return o?r.editor.createModel(o.content,"typescript",t):null}_containsLibFile(e){for(let t of e)if(this.isLibFile(t))return!0;return!1}async fetchLibFilesIfNecessary(e){!this._containsLibFile(e)||await this._fetchLibFiles()}_fetchLibFiles(){return this._fetchLibFilesPromise||(this._fetchLibFilesPromise=this._worker().then(e=>e.getLibFiles()).then(e=>{this._hasFetchedLibFiles=!0,this._libFiles=e})),this._fetchLibFilesPromise}},_;(function(o){o[o.Warning=0]="Warning",o[o.Error=1]="Error",o[o.Suggestion=2]="Suggestion",o[o.Message=3]="Message"})(_||(_={}));var L=class extends k{constructor(e,t,i,o){super(o);this._libFiles=e;this._defaults=t;this._selector=i;this._disposables=[];this._listener=Object.create(null);let u=s=>{if(s.getLanguageId()!==i)return;let c=()=>{let{onlyVisible:b}=this._defaults.getDiagnosticsOptions();b?s.isAttachedToEditor()&&this._doValidate(s):this._doValidate(s)},p,m=s.onDidChangeContent(()=>{clearTimeout(p),p=window.setTimeout(c,500)}),f=s.onDidChangeAttached(()=>{let{onlyVisible:b}=this._defaults.getDiagnosticsOptions();b&&(s.isAttachedToEditor()?c():r.editor.setModelMarkers(s,this._selector,[]))});this._listener[s.uri.toString()]={dispose(){m.dispose(),f.dispose(),clearTimeout(p)}},c()},d=s=>{r.editor.setModelMarkers(s,this._selector,[]);let c=s.uri.toString();this._listener[c]&&(this._listener[c].dispose(),delete this._listener[c])};this._disposables.push(r.editor.onDidCreateModel(s=>u(s))),this._disposables.push(r.editor.onWillDisposeModel(d)),this._disposables.push(r.editor.onDidChangeModelLanguage(s=>{d(s.model),u(s.model)})),this._disposables.push({dispose(){for(let s of r.editor.getModels())d(s)}});let g=()=>{for(let s of r.editor.getModels())d(s),u(s)};this._disposables.push(this._defaults.onDidChange(g)),this._disposables.push(this._defaults.onDidExtraLibsChange(g)),r.editor.getModels().forEach(s=>u(s))}dispose(){this._disposables.forEach(e=>e&&e.dispose()),this._disposables=[]}async _doValidate(e){let t=await this._worker(e.uri);if(e.isDisposed())return;let i=[],{noSyntaxValidation:o,noSemanticValidation:u,noSuggestionDiagnostics:d}=this._defaults.getDiagnosticsOptions();o||i.push(t.getSyntacticDiagnostics(e.uri.toString())),u||i.push(t.getSemanticDiagnostics(e.uri.toString())),d||i.push(t.getSuggestionDiagnostics(e.uri.toString()));let g=await Promise.all(i);if(!g||e.isDisposed())return;let s=g.reduce((p,m)=>m.concat(p),[]).filter(p=>(this._defaults.getDiagnosticsOptions().diagnosticCodesToIgnore||[]).indexOf(p.code)===-1),c=s.map(p=>p.relatedInformation||[]).reduce((p,m)=>m.concat(p),[]).map(p=>p.file?r.Uri.parse(p.file.fileName):null);await this._libFiles.fetchLibFilesIfNecessary(c),!e.isDisposed()&&r.editor.setModelMarkers(e,this._selector,s.map(p=>this._convertDiagnostics(e,p)))}_convertDiagnostics(e,t){let i=t.start||0,o=t.length||1,{lineNumber:u,column:d}=e.getPositionAt(i),{lineNumber:g,column:s}=e.getPositionAt(i+o),c=[];return t.reportsUnnecessary&&c.push(r.MarkerTag.Unnecessary),t.reportsDeprecated&&c.push(r.MarkerTag.Deprecated),{severity:this._tsDiagnosticCategoryToMarkerSeverity(t.category),startLineNumber:u,startColumn:d,endLineNumber:g,endColumn:s,message:D(t.messageText,`
`),code:t.code.toString(),tags:c,relatedInformation:this._convertRelatedInformation(e,t.relatedInformation)}}_convertRelatedInformation(e,t){if(!t)return[];let i=[];return t.forEach(o=>{let u=e;if(o.file&&(u=this._libFiles.getOrCreateModel(o.file.fileName)),!u)return;let d=o.start||0,g=o.length||1,{lineNumber:s,column:c}=u.getPositionAt(d),{lineNumber:p,column:m}=u.getPositionAt(d+g);i.push({resource:u.uri,startLineNumber:s,startColumn:c,endLineNumber:p,endColumn:m,message:D(o.messageText,`
`)})}),i}_tsDiagnosticCategoryToMarkerSeverity(e){switch(e){case 1:return r.MarkerSeverity.Error;case 3:return r.MarkerSeverity.Info;case 0:return r.MarkerSeverity.Warning;case 2:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Info}},y=class extends k{get triggerCharacters(){return["."]}async provideCompletionItems(e,t,i,o){let u=e.getWordUntilPosition(t),d=new r.Range(t.lineNumber,u.startColumn,t.lineNumber,u.endColumn),g=e.uri,s=e.getOffsetAt(t),c=await this._worker(g);if(e.isDisposed())return;let p=await c.getCompletionsAtPosition(g.toString(),s);return!p||e.isDisposed()?void 0:{suggestions:p.entries.map(f=>{let b=d;if(f.replacementSpan){let T=e.getPositionAt(f.replacementSpan.start),I=e.getPositionAt(f.replacementSpan.start+f.replacementSpan.length);b=new r.Range(T.lineNumber,T.column,I.lineNumber,I.column)}let v=[];return f.kindModifiers?.indexOf("deprecated")!==-1&&v.push(r.languages.CompletionItemTag.Deprecated),{uri:g,position:t,offset:s,range:b,label:f.name,insertText:f.name,sortText:f.sortText,kind:y.convertKind(f.kind),tags:v}})}}async resolveCompletionItem(e,t){let i=e,o=i.uri,u=i.position,d=i.offset,s=await(await this._worker(o)).getCompletionEntryDetails(o.toString(),d,i.label);return s?{uri:o,position:u,label:s.name,kind:y.convertKind(s.kind),detail:S(s.displayParts),documentation:{value:y.createDocumentationString(s)}}:i}static convertKind(e){switch(e){case l.primitiveType:case l.keyword:return r.languages.CompletionItemKind.Keyword;case l.variable:case l.localVariable:return r.languages.CompletionItemKind.Variable;case l.memberVariable:case l.memberGetAccessor:case l.memberSetAccessor:return r.languages.CompletionItemKind.Field;case l.function:case l.memberFunction:case l.constructSignature:case l.callSignature:case l.indexSignature:return r.languages.CompletionItemKind.Function;case l.enum:return r.languages.CompletionItemKind.Enum;case l.module:return r.languages.CompletionItemKind.Module;case l.class:return r.languages.CompletionItemKind.Class;case l.interface:return r.languages.CompletionItemKind.Interface;case l.warning:return r.languages.CompletionItemKind.File}return r.languages.CompletionItemKind.Property}static createDocumentationString(e){let t=S(e.documentation);if(e.tags)for(let i of e.tags)t+=`

${Y(i)}`;return t}};function Y(n){let e=`*@${n.name}*`;if(n.name==="param"&&n.text){let[t,...i]=n.text;e+=`\`${t.text}\``,i.length>0&&(e+=` \u2014 ${i.map(o=>o.text).join(" ")}`)}else Array.isArray(n.text)?e+=` \u2014 ${n.text.map(t=>t.text).join(" ")}`:n.text&&(e+=` \u2014 ${n.text}`);return e}var w=class extends k{constructor(){super(...arguments);this.signatureHelpTriggerCharacters=["(",","]}static _toSignatureHelpTriggerReason(e){switch(e.triggerKind){case r.languages.SignatureHelpTriggerKind.TriggerCharacter:return e.triggerCharacter?e.isRetrigger?{kind:"retrigger",triggerCharacter:e.triggerCharacter}:{kind:"characterTyped",triggerCharacter:e.triggerCharacter}:{kind:"invoked"};case r.languages.SignatureHelpTriggerKind.ContentChange:return e.isRetrigger?{kind:"retrigger"}:{kind:"invoked"};case r.languages.SignatureHelpTriggerKind.Invoke:default:return{kind:"invoked"}}}async provideSignatureHelp(e,t,i,o){let u=e.uri,d=e.getOffsetAt(t),g=await this._worker(u);if(e.isDisposed())return;let s=await g.getSignatureHelpItems(u.toString(),d,{triggerReason:w._toSignatureHelpTriggerReason(o)});if(!s||e.isDisposed())return;let c={activeSignature:s.selectedItemIndex,activeParameter:s.argumentIndex,signatures:[]};return s.items.forEach(p=>{let m={label:"",parameters:[]};m.documentation={value:S(p.documentation)},m.label+=S(p.prefixDisplayParts),p.parameters.forEach((f,b,v)=>{let T=S(f.displayParts),I={label:T,documentation:{value:S(f.documentation)}};m.label+=T,m.parameters.push(I),b<v.length-1&&(m.label+=S(p.separatorDisplayParts))}),m.label+=S(p.suffixDisplayParts),c.signatures.push(m)}),{value:c,dispose(){}}}},M=class extends k{async provideHover(e,t,i){let o=e.uri,u=e.getOffsetAt(t),d=await this._worker(o);if(e.isDisposed())return;let g=await d.getQuickInfoAtPosition(o.toString(),u);if(!g||e.isDisposed())return;let s=S(g.documentation),c=g.tags?g.tags.map(m=>Y(m)).join(`  

`):"",p=S(g.displayParts);return{range:this._textSpanToRange(e,g.textSpan),contents:[{value:"```typescript\n"+p+"\n```\n"},{value:s+(c?`

`+c:"")}]}}},A=class extends k{async provideDocumentHighlights(e,t,i){let o=e.uri,u=e.getOffsetAt(t),d=await this._worker(o);if(e.isDisposed())return;let g=await d.getOccurrencesAtPosition(o.toString(),u);if(!(!g||e.isDisposed()))return g.map(s=>({range:this._textSpanToRange(e,s.textSpan),kind:s.isWriteAccess?r.languages.DocumentHighlightKind.Write:r.languages.DocumentHighlightKind.Text}))}},O=class extends k{constructor(e,t){super(t);this._libFiles=e}async provideDefinition(e,t,i){let o=e.uri,u=e.getOffsetAt(t),d=await this._worker(o);if(e.isDisposed())return;let g=await d.getDefinitionAtPosition(o.toString(),u);if(!g||e.isDisposed()||(await this._libFiles.fetchLibFilesIfNecessary(g.map(c=>r.Uri.parse(c.fileName))),e.isDisposed()))return;let s=[];for(let c of g){let p=this._libFiles.getOrCreateModel(c.fileName);p&&s.push({uri:p.uri,range:this._textSpanToRange(p,c.textSpan)})}return s}},R=class extends k{constructor(e,t){super(t);this._libFiles=e}async provideReferences(e,t,i,o){let u=e.uri,d=e.getOffsetAt(t),g=await this._worker(u);if(e.isDisposed())return;let s=await g.getReferencesAtPosition(u.toString(),d);if(!s||e.isDisposed()||(await this._libFiles.fetchLibFilesIfNecessary(s.map(p=>r.Uri.parse(p.fileName))),e.isDisposed()))return;let c=[];for(let p of s){let m=this._libFiles.getOrCreateModel(p.fileName);m&&c.push({uri:m.uri,range:this._textSpanToRange(m,p.textSpan)})}return c}},E=class extends k{async provideDocumentSymbols(e,t){let i=e.uri,o=await this._worker(i);if(e.isDisposed())return;let u=await o.getNavigationBarItems(i.toString());if(!u||e.isDisposed())return;let d=(s,c,p)=>{let m={name:c.text,detail:"",kind:h[c.kind]||r.languages.SymbolKind.Variable,range:this._textSpanToRange(e,c.spans[0]),selectionRange:this._textSpanToRange(e,c.spans[0]),tags:[]};if(p&&(m.containerName=p),c.childItems&&c.childItems.length>0)for(let f of c.childItems)d(s,f,m.name);s.push(m)},g=[];return u.forEach(s=>d(g,s)),g}},l=class{};l.unknown="",l.keyword="keyword",l.script="script",l.module="module",l.class="class",l.interface="interface",l.type="type",l.enum="enum",l.variable="var",l.localVariable="local var",l.function="function",l.localFunction="local function",l.memberFunction="method",l.memberGetAccessor="getter",l.memberSetAccessor="setter",l.memberVariable="property",l.constructorImplementation="constructor",l.callSignature="call",l.indexSignature="index",l.constructSignature="construct",l.parameter="parameter",l.typeParameter="type parameter",l.primitiveType="primitive type",l.label="label",l.alias="alias",l.const="const",l.let="let",l.warning="warning";var h=Object.create(null);h[l.module]=r.languages.SymbolKind.Module;h[l.class]=r.languages.SymbolKind.Class;h[l.enum]=r.languages.SymbolKind.Enum;h[l.interface]=r.languages.SymbolKind.Interface;h[l.memberFunction]=r.languages.SymbolKind.Method;h[l.memberVariable]=r.languages.SymbolKind.Property;h[l.memberGetAccessor]=r.languages.SymbolKind.Property;h[l.memberSetAccessor]=r.languages.SymbolKind.Property;h[l.variable]=r.languages.SymbolKind.Variable;h[l.const]=r.languages.SymbolKind.Variable;h[l.localVariable]=r.languages.SymbolKind.Variable;h[l.variable]=r.languages.SymbolKind.Variable;h[l.function]=r.languages.SymbolKind.Function;h[l.localFunction]=r.languages.SymbolKind.Function;var x=class extends k{static _convertOptions(e){return{ConvertTabsToSpaces:e.insertSpaces,TabSize:e.tabSize,IndentSize:e.tabSize,IndentStyle:2,NewLineCharacter:`
`,InsertSpaceAfterCommaDelimiter:!0,InsertSpaceAfterSemicolonInForStatements:!0,InsertSpaceBeforeAndAfterBinaryOperators:!0,InsertSpaceAfterKeywordsInControlFlowStatements:!0,InsertSpaceAfterFunctionKeywordForAnonymousFunctions:!0,InsertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis:!1,InsertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets:!1,InsertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces:!1,PlaceOpenBraceOnNewLineForControlBlocks:!1,PlaceOpenBraceOnNewLineForFunctions:!1}}_convertTextChanges(e,t){return{text:t.newText,range:this._textSpanToRange(e,t.span)}}},N=class extends x{async provideDocumentRangeFormattingEdits(e,t,i,o){let u=e.uri,d=e.getOffsetAt({lineNumber:t.startLineNumber,column:t.startColumn}),g=e.getOffsetAt({lineNumber:t.endLineNumber,column:t.endColumn}),s=await this._worker(u);if(e.isDisposed())return;let c=await s.getFormattingEditsForRange(u.toString(),d,g,x._convertOptions(i));if(!(!c||e.isDisposed()))return c.map(p=>this._convertTextChanges(e,p))}},W=class extends x{get autoFormatTriggerCharacters(){return[";","}",`
`]}async provideOnTypeFormattingEdits(e,t,i,o,u){let d=e.uri,g=e.getOffsetAt(t),s=await this._worker(d);if(e.isDisposed())return;let c=await s.getFormattingEditsAfterKeystroke(d.toString(),g,i,x._convertOptions(o));if(!(!c||e.isDisposed()))return c.map(p=>this._convertTextChanges(e,p))}},H=class extends x{async provideCodeActions(e,t,i,o){let u=e.uri,d=e.getOffsetAt({lineNumber:t.startLineNumber,column:t.startColumn}),g=e.getOffsetAt({lineNumber:t.endLineNumber,column:t.endColumn}),s=x._convertOptions(e.getOptions()),c=i.markers.filter(b=>b.code).map(b=>b.code).map(Number),p=await this._worker(u);if(e.isDisposed())return;let m=await p.getCodeFixesAtPosition(u.toString(),d,g,c,s);return!m||e.isDisposed()?{actions:[],dispose:()=>{}}:{actions:m.filter(b=>b.changes.filter(v=>v.isNewFile).length===0).map(b=>this._tsCodeFixActionToMonacoCodeAction(e,i,b)),dispose:()=>{}}}_tsCodeFixActionToMonacoCodeAction(e,t,i){let o=[];for(let d of i.changes)for(let g of d.textChanges)o.push({resource:e.uri,edit:{range:this._textSpanToRange(e,g.span),text:g.newText}});return{title:i.description,edit:{edits:o},diagnostics:t.markers,kind:"quickfix"}}},U=class extends k{constructor(e,t){super(t);this._libFiles=e}async provideRenameEdits(e,t,i,o){let u=e.uri,d=u.toString(),g=e.getOffsetAt(t),s=await this._worker(u);if(e.isDisposed())return;let c=await s.getRenameInfo(d,g,{allowRenameOfImportPath:!1});if(c.canRename===!1)return{edits:[],rejectReason:c.localizedErrorMessage};if(c.fileToRename!==void 0)throw new Error("Renaming files is not supported.");let p=await s.findRenameLocations(d,g,!1,!1,!1);if(!p||e.isDisposed())return;let m=[];for(let f of p){let b=this._libFiles.getOrCreateModel(f.fileName);if(b)m.push({resource:b.uri,edit:{range:this._textSpanToRange(b,f.textSpan),text:i}});else throw new Error(`Unknown file ${f.fileName}.`)}return{edits:m}}},V=class extends k{async provideInlayHints(e,t,i){let o=e.uri,u=o.toString(),d=e.getOffsetAt({lineNumber:t.startLineNumber,column:t.startColumn}),g=e.getOffsetAt({lineNumber:t.endLineNumber,column:t.endColumn}),s=await this._worker(o);return e.isDisposed()?null:{hints:(await s.provideInlayHints(u,d,g)).map(m=>({...m,label:m.text,position:e.getPositionAt(m.position),kind:this._convertHintKind(m.kind)})),dispose:()=>{}}}_convertHintKind(e){switch(e){case"Parameter":return r.languages.InlayHintKind.Parameter;case"Type":return r.languages.InlayHintKind.Type;default:return r.languages.InlayHintKind.Other}}};var z,J;function le(n){J=Z(n,"typescript")}function ce(n){z=Z(n,"javascript")}function ue(){return new Promise((n,e)=>{if(!z)return e("JavaScript not registered!");n(z)})}function ge(){return new Promise((n,e)=>{if(!J)return e("TypeScript not registered!");n(J)})}function Z(n,e){let t=new C(e,n),i=(...u)=>t.getLanguageServiceWorker(...u),o=new F(i);return r.languages.registerCompletionItemProvider(e,new y(i)),r.languages.registerSignatureHelpProvider(e,new w(i)),r.languages.registerHoverProvider(e,new M(i)),r.languages.registerDocumentHighlightProvider(e,new A(i)),r.languages.registerDefinitionProvider(e,new O(o,i)),r.languages.registerReferenceProvider(e,new R(o,i)),r.languages.registerDocumentSymbolProvider(e,new E(i)),r.languages.registerDocumentRangeFormattingEditProvider(e,new N(i)),r.languages.registerOnTypeFormattingEditProvider(e,new W(i)),r.languages.registerCodeActionProvider(e,new H(i)),r.languages.registerRenameProvider(e,new U(o,i)),r.languages.registerInlayHintsProvider(e,new V(i)),new L(o,n,e,i),i}return pe;})();
return moduleExports;
});
